{ #####################################################################}
{ ###### This program was automatically generated by CardBuilder ######}
{ ###### KylixDriver's card building automation tool             ######}
{ ###### Copyright (C) 2002-2004 ETSoft Tenzor.Net               ######}
{ ###### All rights reserved.                                    ######}
{ ###### e-mail: etsoft@tenzor.net                               ######}
{ #####################################################################}
{ ---------------------------------------------------------------------}
{        This is the Library module                                    }
{ ---------------------------------------------------------------------}

unit kdCustomCard1_Lib;

interface
uses
  Classes, SysUtils, kdclxcore, kdranges, kdinterrupt, kdregister;

procedure Access_TkdMemoryRange (var AMemoryRange: TkdMemoryRange);
procedure Access_TkdDirectRRAMRange (var ADirectRRAMRange: TkdDirectRRAMRange);
procedure Access_TkdPortRange (var APortRange: TkdPortRange);
procedure Access_TkdHWRangeRegister (var AHWRangeRegister: TkdHWRangeRegister);

type
  TUserModeInterruptHandler = class
  public
    procedure InterruptHandlerMethod (Sender: TkdInterrupt);
  end;

procedure Access_TkdInterrupt (var AnInterrupt: TkdInterrupt);

implementation
uses
  kdCustomCard1_Diag;

{ Module-level definition of messaging contants }
{ for kdranges module }
Const
  BufferAllocationErrorMessage = 'Out of memory while allocating a buffer';
  WriteDataSuccessMessage = 'The data has been successfully written!';
  NothingToTransferMessage = 'Nothing to transfer';

{ Module-level definition of messaging contants }
{ for kdregister or/and kdpcihdr module(s) }
  InputHexValueMessage = 'Input a hexadecimal value to write (eg. $ff or FF):';
  WriteValueSuccessMessage = 'The value has been successfully written!';

{ Class-level definition of messaging constants for TkdHWRange }
Const
  PropertiesConflictMessage: String = 'Properties conflict!';
  TransferDirectionMessage1: String = 'TransferDir property is specified for READ.';
  TransferDirectionMessage2: String = 'TransferDir property is specified for WRITE.';

Type
  PByte = ^Byte;
  PWord = ^Word;
  PDWord = ^LongWord;

Var
  ptr1: PByte;
  ptr2: PWord;
  ptr4: PDWord;
  Buffer: Pointer;
  transfer_dir_value: String[10];
  transfer_size_value: String[20];

procedure TkdHWRange_TransferAndOutput (AkdHWRange: TkdHWRange; TrSize: Byte; TrCount: LongWord);
var
  i: Integer;
  CurrValue: LongWord;
begin
  with AkdHWRange do
  begin
    try
      GetMem (Buffer, TrCount * TrSize);
      if Assigned(Buffer) then
      begin
        try
          if AkdHWRange is TkdPortRange then TkdPortRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize) 
            else TkdMemoryRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize); 
          if LastError = 0 then
          begin
            ptr1:= Buffer; ptr2:= Buffer; ptr4:= Buffer;
            Writeln ('Hexadecimal data read is: ');
            for i:= 0 to TrCount - 1 do
            begin
              CurrValue:= 0;
              case TrSize of
                1: begin CurrValue:= ptr1^; Inc(ptr1) end;
                2: begin CurrValue:= ptr2^; Inc(ptr2) end;
                4: begin CurrValue:= ptr4^; Inc(ptr4) end;
              end;
              Write (IntToHex(CurrValue, TrSize * 2),' ');
            end;
            Writeln;
          end else Writeln ('Error reading from the range');
        finally
          FreeMem (Buffer)
        end;
      end else Writeln (NothingToTransferMessage)  // transfer count is zero
    except
      on EOutOfMemory do Writeln(BufferAllocationErrorMessage);
    end;
  end
end;

procedure TkdHWRange_InputAndTransfer (AkdHWRange: TkdHWRange; TrSize: Byte; TrCount: LongWord);
var
  line: String[255];
  i: Integer;
  Value: Int64;
begin
    try
      GetMem (Buffer, TrCount * TrSize);
      if Assigned(Buffer) then
      begin
        try
          ptr1:= Buffer; ptr2:= Buffer; ptr4:= Buffer;
          Writeln('Input hexadecimal data to write (eg. $ff or FF) with Enter delimiter:');
          for i:= 0 to TrCount - 1 do
          begin
            Readln(line);
            if Copy (line, 1, 1) <> '$' then line:= '$' + line;
            Value:= 0;
            try
	      if Value = 0 then
                Value:= StrToInt64(line);
            except
              on EConvertError do begin Writeln (IllegalInputMessage); Exit end
            end;
            case TrSize of
              1:  begin ptr1^:= Byte(Value); Inc(ptr1) end;
              2:  begin ptr2^:= Word(Value); Inc(ptr2) end;
              4:  begin ptr4^:= LongWord(Value); Inc(ptr4) end;
            end;
          end;
          if AkdHWRange is TkdPortRange then TkdPortRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize) 
            else TkdMemoryRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize); 
          if AkdHWRange.LastError = 0 then Writeln(WriteDataSuccessMessage) else Writeln('Error writing to the range');
        finally
          FreeMem (Buffer)
        end;
      end else Writeln (NothingToTransferMessage)  // transfer count is zero
    except
      on EOutOfMemory do Writeln(BufferAllocationErrorMessage);
    end;
end;


procedure Access_TkdMemoryRange;
var
  cmd: Integer;
  line: String[255];
begin
  repeat
    with AMemoryRange do
    begin
      if TransferDir = tdRead then transfer_dir_value:= 'READ' else transfer_dir_value:= 'WRITE';
      if TransferSize = tsByte then transfer_size_value:= 'BYTE (8 bit)' else
      if TransferSize = tsWord then transfer_size_value:= 'WORD (16 bit)' else transfer_size_value:= 'DWORD (32 bit)';
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Toggle TransferAutoInc property: ', TransferAutoInc);
      Writeln('2.  Change TransferCount property: ', TransferCount);
      Writeln('3.  Toggle TransferDir property: ', transfer_dir_value);
      Writeln('4.  Change TransferOffset property: ', TransferOffset);
      Writeln('5.  Toggle TransferSize property: ', transfer_size_value);
      Writeln('6.  Read from the memory range');
      Writeln('7.  Write to the memory range');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             try
               if TransferAutoInc then TransferAutoInc:= False else TransferAutoInc:= True
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        2: begin
             Write ('Set it to value (decimal): ');
             Readln (line);
             try
               TransferCount:= LongWord(StrToInt64(line));
             except
               on EConvertError do Writeln(IllegalInputMessage)
               else Writeln(PropertiesConflictMessage)
             end
           end;
        3: begin
             if TransferDir = tdWrite then TransferDir:= tdRead else TransferDir:= tdWrite
           end;
        4: begin
             Write ('Set it to value (decimal): ');
             Readln (line);
             try
               TransferOffset:= LongWord(StrToInt64(line));
             except
               on EConvertError do Writeln(IllegalInputMessage)
               else Writeln(PropertiesConflictMessage)
             end
           end;
        5: begin
             try
               if TransferSize = tsByte then TransferSize:= tsWord else 
               if TransferSize = tsWord then TransferSize:= tsDWord else TransferSize:= tsByte
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        6: begin
             if TransferDir = tdWrite then Writeln (TransferDirectionMessage2) else
               TkdHWRange_TransferAndOutput (AMemoryRange, GetTransferSize(TransferSize), TransferCount);
           end;
        7: begin
             if TransferDir = tdRead then Writeln(TransferDirectionMessage1) else
               TkdHWRange_InputAndTransfer (AMemoryRange, GetTransferSize(TransferSize), TransferCount);
           end;
      end
    end
  until cmd = 99
end;

function TkdDirectMemoryRange_InputOffsetAndCount (var TrOffset: LongWord; var TrCount: LongWord; RangeFrom, RangeTo: Int64): Boolean;
(* comment: RangeFrom & RangeTo are Int64 necessary for correct comparison *)
var
  line: String[255];
begin
  Result:= False;
  try
    Write ('Enter offset to access the range from (decimal): ');
    Readln (line);
    TrOffset:= LongWord(StrToInt64(line));
    if RangeFrom + TrOffset > RangeTo then
    begin
      Writeln ('The value exceeds the upper bound of the range.'); Exit
    end;
  except
    on EConvertError do begin Writeln(IllegalInputMessage); Exit end
  end;
  try
    Write ('Enter how many bytes to access (decimal): ');
    Readln (line);
    TrCount:= LongWord(StrToInt64(line));
    if RangeFrom + TrOffset + TrCount > RangeTo then
    begin
      Writeln ('The transfer would exceed the upper bound of the range.'); Exit
    end
  except
    on EConvertError do begin Writeln(IllegalInputMessage); Exit end
  end;
  Result:= True
end;

procedure TkdDirectMemoryRange_TransferAndOutput (TrOffset, TrCount: LongWord; RangeFrom, RangeTo: Int64; UserDirectAddr: Pointer);
(* comment: RangeFrom & RangeTo are Int64 necessary for correct comparison *)
const
  BytesPerLine = 8;
type
  TByteArray = array[0..$FFFF] of Byte;
var
  CurrAddr, i, j: LongWord;
  s: AnsiString;
  b: Integer;
  ch: Char;
  Ofs, Ofs0: Word;
  LinearAddress: ^TByteArray;
  PhysAddr, PhysSize: LongWord;
begin
  PhysAddr:= RangeFrom + TrOffset;
  if TrCount + TrOffset > $FFFF then
    PhysSize:= $FFFF - TrOffset else PhysSize:= TrCount;
  LinearAddress:= Pointer(LongWord(UserDirectAddr) + TrOffset);
  if LinearAddress <> nil then
  begin
    CurrAddr:= PhysAddr;
    Ofs:= 0;
    Ofs0:= 0;
    for i:= 1 to PhysSize div BytesPerLine do
    begin
      s:='ADDRESS -> ' + IntToHex(CurrAddr, 8) + '  DATA -> ';
      for j:= 1 to BytesPerLine do
      begin
        s:= s + IntToHex(LinearAddress^[ofs], 2);
        Inc(Ofs);
      end;
      s:= s + ' ';
      for j:= 1 to BytesPerLine do
      begin
        b:= LinearAddress^[Ofs0];
        Inc (Ofs0);
        if (b >= $20) and (b <= 127) then ch:= Chr(b) else ch:= '.'; s:= s + ch;
      end;
      Writeln (s);
      CurrAddr:= CurrAddr + BytesPerLine;
    end;
    Writeln ('The data has been successfully read!')
  end
end;

procedure TkdDirectMemoryRange_InputAndTransfer (TrOffset, TrCount: LongWord; UserDirectAddr: Pointer);
var
  line: String[255];
  i: Integer;
  LinearAddress: ^Byte;
  Value: Int64;
begin
  LinearAddress:= Pointer(LongWord(UserDirectAddr) + TrOffset);
  if LinearAddress <> nil then
  begin
    try
      GetMem (Buffer, TrCount * SizeOf(Byte));
      if Assigned(Buffer) then
      begin
        try
          try
            ptr1:= Buffer;
            Writeln('Input hexadecimal byte-sized data to write (eg. $ff or FF) with Enter delimiter:');
            for i:= 0 to TrCount - 1 do
            begin
              Readln(line);
              if Copy (line, 1, 1) <> '$' then line:= '$' + line;
              Value:= 0;
              try
	        if Value = 0 then
                  Value:= StrToInt64(line);
              except
                on EConvertError do begin Writeln (IllegalInputMessage); Exit end
              end;
              ptr1^:= Byte(Value); Inc(ptr1)
            end;
            ptr1:= Buffer;
            for i:= 0 to TrCount - 1 do
            begin
              LinearAddress^:= ptr1^;
              Inc(LinearAddress);
              Inc(ptr1);
            end;
            Writeln(WriteDataSuccessMessage);
          except
            raise; (* reraise an unpredictable exception, maybe ?? *)
          end
        finally
          FreeMem (Buffer)
        end;
      end else Writeln (NothingToTransferMessage)  // transfer count is zero
    except
      on EOutOfMemory do Writeln(BufferAllocationErrorMessage);
    end;
  end
end;

procedure Access_TkdDirectRRAMRange;
var
  cmd: Integer;
  line: String[255];
  TrOffset: LongWord;
  TrCount: LongWord;
begin
  repeat
    with ADirectRRAMRange do
    begin
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Directly read from the RAM range');
      Writeln('2.  Directly write to the RAM range');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             if TkdDirectMemoryRange_InputOffsetAndCount (TrOffset, TrCount, StrToInt64(RangeFrom), StrToInt64(RangeTo)) then
               TkdDirectMemoryRange_TransferAndOutput (TrOffset, TrCount, StrToInt64(RangeFrom), StrToInt64(RangeTo), UserDirectAddr);
           end;
        2: begin
             if not (mpPROT_WRITE in MemProt) then
               Writeln ('Hmm... unsure to write because PROT_WRITE flag is not currently set. You will probably hang.') else
                 if TkdDirectMemoryRange_InputOffsetAndCount (TrOffset, TrCount, StrToInt64(RangeFrom), StrToInt64(RangeTo)) then
                   TkdDirectMemoryRange_InputAndTransfer (TrOffset, TrCount, UserDirectAddr);
           end;
      end
    end
  until cmd = 99
end;

procedure Access_TkdPortRange;
var
  cmd: Integer;
  line: String[255];
  arranged_like_value: String[10];
  transfer_type_value: String[10];
begin
  repeat
    with APortRange do
    begin
      if ArrangedLike = alMemory then arranged_like_value:= 'MEMORY' else arranged_like_value:= 'PORT';
      if TransferDir = tdRead then transfer_dir_value:= 'READ' else transfer_dir_value:= 'WRITE';
      if TransferSize = tsByte then transfer_size_value:= 'BYTE (8 bit)' else
      if TransferSize = tsWord then transfer_size_value:= 'WORD (16 bit)' else transfer_size_value:= 'DWORD (32 bit)';
      if TransferType = ttDefault then transfer_type_value:= 'DEFAULT' else
      if TransferType = ttString then transfer_type_value:= 'STRING' else transfer_type_value:= 'PAUSING';
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Toggle ArrangedLike property: ', arranged_like_value);
      Writeln('2.  Toggle TransferAutoInc property: ', TransferAutoInc);
      Writeln('3.  Change TransferCount property: ', TransferCount);
      Writeln('4.  Toggle TransferDir property: ', transfer_dir_value);
      Writeln('5.  Change TransferOffset property: ', TransferOffset);
      Writeln('6.  Toggle TransferSize property: ', transfer_size_value);
      Writeln('7.  Toggle TransferType property: ', transfer_type_value);
      Writeln('8.  Read from the port range');
      Writeln('9.  Write to the port range');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             try
               if ArrangedLike = alMemory then ArrangedLike:= alPort else ArrangedLike:= alMemory
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        2: begin
             try
               if TransferAutoInc then TransferAutoInc:= False else TransferAutoInc:= True
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        3: begin
             Write ('Set it to value (decimal): ');
             Readln (line);
             try
               TransferCount:= LongWord(StrToInt64(line));
             except
               on EConvertError do Writeln(IllegalInputMessage)
               else Writeln(PropertiesConflictMessage)
             end
           end;
        4: begin
             if TransferDir = tdWrite then TransferDir:= tdRead else TransferDir:= tdWrite
           end;
        5: begin
             Write ('Set it to value (decimal): ');
             Readln (line);
             try
               TransferOffset:= LongWord(StrToInt64(line));
             except
               on EConvertError do Writeln(IllegalInputMessage)
               else Writeln(PropertiesConflictMessage)
             end
           end;
        6: begin
             try
               if TransferSize = tsByte then TransferSize:= tsWord else 
               if TransferSize = tsWord then TransferSize:= tsDWord else TransferSize:= tsByte
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        7: begin
             try
               if TransferType = ttDefault then TransferType:= ttString else 
               if TransferType = ttString then TransferType:= ttPausing else TransferType:= ttDefault
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        8: begin
             if TransferDir = tdWrite then Writeln (TransferDirectionMessage2) else
               TkdHWRange_TransferAndOutput (APortRange, GetTransferSize(TransferSize), TransferCount);
           end;
        9: begin
             if TransferDir = tdRead then Writeln(TransferDirectionMessage1) else
               TkdHWRange_InputAndTransfer (APortRange, GetTransferSize(TransferSize), TransferCount);
           end;
      end
    end
  until cmd = 99
end;

procedure Access_TkdHWRangeRegister;
var
  cmd: Integer;
  line: String[255];
  CurrValue: LongWord;
  ValueEntered: LongWord;
begin
  repeat
    with AHWRangeRegister do
    begin
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Read from the register');
      Writeln('2.  Write to the register');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             CurrValue:= Value;
             if LastError = 0 then
               Writeln ('Hexadecimal value read is: ', IntToHex(CurrValue, GetRegisterSize(Size) * 2),' ') else
                 Writeln('Error reading from the register');
           end;
        2: begin
             Writeln(InputHexValueMessage);
             Readln(line);
             if Copy (line, 1, 1) <> '$' then line:= '$' + line;
             ValueEntered:= 0;
             try
	       if ValueEntered = 0 then
                 ValueEntered:= StrToInt64(line);
             except
               on EConvertError do begin Writeln (IllegalInputMessage); Exit end
             end;
             CurrValue:= 0;
             case GetRegisterSize(Size) of
               1:  CurrValue:= Byte(ValueEntered);
               2:  CurrValue:= Word(ValueEntered);
               4:  CurrValue:= LongWord(ValueEntered);
             end;
             Value:= CurrValue; 
             if LastError = 0 then Writeln(WriteValueSuccessMessage) else Writeln('Error writing to the register');
           end;
      end
    end
  until cmd = 99
end;

procedure TUserModeInterruptHandler.InterruptHandlerMethod (Sender: TkdInterrupt);
begin
  Writeln ('Got interrupt number ', Sender.InterruptNumber, ' Count ', Sender.InterruptsDirected, ' (Press Enter to view menu)');
end;

procedure Access_TkdInterrupt;
var
  cmd: Integer;
  line: String[255];
begin
  repeat
    with AnInterrupt do
    begin
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Enable Interrupt');
      Writeln('2.  Disable Interrupt');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             if Enabled then Writeln ('The interrupt is already enabled') else
               if not EnableInterrupt then Writeln ('Failed enabling the interrupt') else
                 Writeln ('The interrupt has been successfully enabled!');
           end;
        2: begin
             if not Enabled then Writeln ('The interrupt is already disabled') else
             begin
               DisableInterrupt;
               Writeln ('The interrupt has been successfully disabled!');
             end
           end;
      end
    end
  until cmd = 99
end;



end.
