{ #####################################################################}
{ ###### This program was automatically generated by CardBuilder ######}
{ ###### KylixDriver's card building automation tool             ######}
{ ###### Copyright (C) 2002-2004 ETSoft Tenzor.Net               ######}
{ ###### All rights reserved.                                    ######}
{ ###### e-mail: etsoft@tenzor.net                               ######}
{ #####################################################################}
{ ---------------------------------------------------------------------}
{        This is the Library module                                    }
{ ---------------------------------------------------------------------}

unit kdCustomCard1_Lib;

interface
uses
  Classes, SysUtils, kdclxcore, kdranges, kdregister, kdinterrupt;

procedure Access_TkdPortRange (var APortRange: TkdPortRange);
procedure Access_TkdHWRangeRegister (var AHWRangeRegister: TkdHWRangeRegister);

type
  TUserModeInterruptHandler = class
  public
    procedure InterruptHandlerMethod (Sender: TkdInterrupt);
  end;

procedure Access_TkdInterrupt (var AnInterrupt: TkdInterrupt);

implementation
uses
  kdCustomCard1_Diag;

{ Module-level definition of messaging contants }
{ for kdranges module }
Const
  BufferAllocationErrorMessage = 'Out of memory while allocating a buffer';
  WriteDataSuccessMessage = 'The data has been successfully written!';
  NothingToTransferMessage = 'Nothing to transfer';

{ Module-level definition of messaging contants }
{ for kdregister or/and kdpcihdr module(s) }
  InputHexValueMessage = 'Input a hexadecimal value to write (eg. $ff or FF):';
  WriteValueSuccessMessage = 'The value has been successfully written!';

{ Class-level definition of messaging constants for TkdHWRange }
Const
  PropertiesConflictMessage: String = 'Properties conflict!';
  TransferDirectionMessage1: String = 'TransferDir property is specified for READ.';
  TransferDirectionMessage2: String = 'TransferDir property is specified for WRITE.';

Type
  PByte = ^Byte;
  PWord = ^Word;
  PDWord = ^LongWord;

Var
  ptr1: PByte;
  ptr2: PWord;
  ptr4: PDWord;
  Buffer: Pointer;
  transfer_dir_value: String[10];
  transfer_size_value: String[20];

procedure TkdHWRange_TransferAndOutput (AkdHWRange: TkdHWRange; TrSize: Byte; TrCount: LongWord);
var
  i: Integer;
  CurrValue: LongWord;
begin
  with AkdHWRange do
  begin
    try
      GetMem (Buffer, TrCount * TrSize);
      if Assigned(Buffer) then
      begin
        try
          if AkdHWRange is TkdPortRange then TkdPortRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize) 
            else TkdMemoryRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize); 
          if LastError = 0 then
          begin
            ptr1:= Buffer; ptr2:= Buffer; ptr4:= Buffer;
            Writeln ('Hexadecimal data read is: ');
            for i:= 0 to TrCount - 1 do
            begin
              CurrValue:= 0;
              case TrSize of
                1: begin CurrValue:= ptr1^; Inc(ptr1) end;
                2: begin CurrValue:= ptr2^; Inc(ptr2) end;
                4: begin CurrValue:= ptr4^; Inc(ptr4) end;
              end;
              Write (IntToHex(CurrValue, TrSize * 2),' ');
            end;
            Writeln;
          end else Writeln ('Error reading from the range');
        finally
          FreeMem (Buffer)
        end;
      end else Writeln (NothingToTransferMessage)  // transfer count is zero
    except
      on EOutOfMemory do Writeln(BufferAllocationErrorMessage);
    end;
  end
end;

procedure TkdHWRange_InputAndTransfer (AkdHWRange: TkdHWRange; TrSize: Byte; TrCount: LongWord);
var
  line: String[255];
  i: Integer;
  Value: Int64;
begin
    try
      GetMem (Buffer, TrCount * TrSize);
      if Assigned(Buffer) then
      begin
        try
          ptr1:= Buffer; ptr2:= Buffer; ptr4:= Buffer;
          Writeln('Input hexadecimal data to write (eg. $ff or FF) with Enter delimiter:');
          for i:= 0 to TrCount - 1 do
          begin
            Readln(line);
            if Copy (line, 1, 1) <> '$' then line:= '$' + line;
            Value:= 0;
            try
	      if Value = 0 then
                Value:= StrToInt64(line);
            except
              on EConvertError do begin Writeln (IllegalInputMessage); Exit end
            end;
            case TrSize of
              1:  begin ptr1^:= Byte(Value); Inc(ptr1) end;
              2:  begin ptr2^:= Word(Value); Inc(ptr2) end;
              4:  begin ptr4^:= LongWord(Value); Inc(ptr4) end;
            end;
          end;
          if AkdHWRange is TkdPortRange then TkdPortRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize) 
            else TkdMemoryRange(AkdHWRange).Transfer (Buffer, TrCount * TrSize); 
          if AkdHWRange.LastError = 0 then Writeln(WriteDataSuccessMessage) else Writeln('Error writing to the range');
        finally
          FreeMem (Buffer)
        end;
      end else Writeln (NothingToTransferMessage)  // transfer count is zero
    except
      on EOutOfMemory do Writeln(BufferAllocationErrorMessage);
    end;
end;

procedure Access_TkdPortRange;
var
  cmd: Integer;
  line: String[255];
  arranged_like_value: String[10];
  transfer_type_value: String[10];
begin
  repeat
    with APortRange do
    begin
      if ArrangedLike = alMemory then arranged_like_value:= 'MEMORY' else arranged_like_value:= 'PORT';
      if TransferDir = tdRead then transfer_dir_value:= 'READ' else transfer_dir_value:= 'WRITE';
      if TransferSize = tsByte then transfer_size_value:= 'BYTE (8 bit)' else
      if TransferSize = tsWord then transfer_size_value:= 'WORD (16 bit)' else transfer_size_value:= 'DWORD (32 bit)';
      if TransferType = ttDefault then transfer_type_value:= 'DEFAULT' else
      if TransferType = ttString then transfer_type_value:= 'STRING' else transfer_type_value:= 'PAUSING';
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Toggle ArrangedLike property: ', arranged_like_value);
      Writeln('2.  Toggle TransferAutoInc property: ', TransferAutoInc);
      Writeln('3.  Change TransferCount property: ', TransferCount);
      Writeln('4.  Toggle TransferDir property: ', transfer_dir_value);
      Writeln('5.  Change TransferOffset property: ', TransferOffset);
      Writeln('6.  Toggle TransferSize property: ', transfer_size_value);
      Writeln('7.  Toggle TransferType property: ', transfer_type_value);
      Writeln('8.  Read from the port range');
      Writeln('9.  Write to the port range');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             try
               if ArrangedLike = alMemory then ArrangedLike:= alPort else ArrangedLike:= alMemory
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        2: begin
             try
               if TransferAutoInc then TransferAutoInc:= False else TransferAutoInc:= True
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        3: begin
             Write ('Set it to value (decimal): ');
             Readln (line);
             try
               TransferCount:= LongWord(StrToInt64(line));
             except
               on EConvertError do Writeln(IllegalInputMessage)
               else Writeln(PropertiesConflictMessage)
             end
           end;
        4: begin
             if TransferDir = tdWrite then TransferDir:= tdRead else TransferDir:= tdWrite
           end;
        5: begin
             Write ('Set it to value (decimal): ');
             Readln (line);
             try
               TransferOffset:= LongWord(StrToInt64(line));
             except
               on EConvertError do Writeln(IllegalInputMessage)
               else Writeln(PropertiesConflictMessage)
             end
           end;
        6: begin
             try
               if TransferSize = tsByte then TransferSize:= tsWord else 
               if TransferSize = tsWord then TransferSize:= tsDWord else TransferSize:= tsByte
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        7: begin
             try
               if TransferType = ttDefault then TransferType:= ttString else 
               if TransferType = ttString then TransferType:= ttPausing else TransferType:= ttDefault
             except
               Writeln(PropertiesConflictMessage);
             end
           end;
        8: begin
             if TransferDir = tdWrite then Writeln (TransferDirectionMessage2) else
               TkdHWRange_TransferAndOutput (APortRange, GetTransferSize(TransferSize), TransferCount);
           end;
        9: begin
             if TransferDir = tdRead then Writeln(TransferDirectionMessage1) else
               TkdHWRange_InputAndTransfer (APortRange, GetTransferSize(TransferSize), TransferCount);
           end;
      end
    end
  until cmd = 99
end;

procedure Access_TkdHWRangeRegister;
var
  cmd: Integer;
  line: String[255];
  CurrValue: LongWord;
  ValueEntered: LongWord;
begin
  repeat
    with AHWRangeRegister do
    begin
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Read from the register');
      Writeln('2.  Write to the register');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             CurrValue:= Value;
             if LastError = 0 then
               Writeln ('Hexadecimal value read is: ', IntToHex(CurrValue, GetRegisterSize(Size) * 2),' ') else
                 Writeln('Error reading from the register');
           end;
        2: begin
             Writeln(InputHexValueMessage);
             Readln(line);
             if Copy (line, 1, 1) <> '$' then line:= '$' + line;
             ValueEntered:= 0;
             try
               if ValueEntered = 0 then ValueEntered:= StrToInt64(line);
             except
               on EConvertError do begin Writeln (IllegalInputMessage); Exit end
             end;
             CurrValue:= 0;
             case GetRegisterSize(Size) of
               1:  CurrValue:= Byte(ValueEntered);
               2:  CurrValue:= Word(ValueEntered);
               4:  CurrValue:= LongWord(ValueEntered);
             end;
             Value:= CurrValue; 
             if LastError = 0 then Writeln(WriteValueSuccessMessage) else Writeln('Error writing to the register');
           end;
      end
    end
  until cmd = 99
end;

procedure TUserModeInterruptHandler.InterruptHandlerMethod (Sender: TkdInterrupt);
begin
  Writeln ('Got interrupt number ', Sender.InterruptNumber, ' Count ', Sender.InterruptsDirected, ' (Press Enter to view menu)');
end;

procedure Access_TkdInterrupt;
var
  cmd: Integer;
  line: String[255];
begin
  repeat
    with AnInterrupt do
    begin
      Writeln;
      Writeln(Name,' access menu');
      Writeln('------------------------------');
      Writeln('1.  Enable Interrupt');
      Writeln('2.  Disable Interrupt');
      Writeln('99. Exit');
      Write('Enter option: ');
      Readln(line);
      cmd:= 0;
      try
        cmd:= StrToInt(line);
      except
        on EConvertError do if Length (line) > 0 then Writeln (IllegalInputMessage);
      end;
      case cmd of
        1: begin
             if Enabled then Writeln ('The interrupt is already enabled') else
               if not EnableInterrupt then Writeln ('Failed enabling the interrupt') else
                 Writeln ('The interrupt has been successfully enabled!');
           end;
        2: begin
             if not Enabled then Writeln ('The interrupt is already disabled') else
             begin
               DisableInterrupt;
               Writeln ('The interrupt has been successfully disabled!');
             end
           end;
      end
    end
  until cmd = 99
end;



end.
