unit Unit1;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  kdinterrupt, kdregister, kdclxcore, kdranges, QStdCtrls, Libc, KernelIoctl;

type
  TForm1 = class(TForm)
    ReadCMOSTimeNativeButton: TButton;
    NativePromptLabel: TLabel;
    ReadCMOSTimeButton: TButton;
    ReadCMOSTimeNativeLabel: TLabel;
    SoundOnNativeButton: TButton;
    SoundOffNativeButton: TButton;
    ReadCMOSTimeLabel: TLabel;
    AltTabNativeButton: TButton;
    SoundOnButton: TButton;
    SoundOffButton: TButton;
    AltTabButton: TButton;
    NativeLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SoundOnNativeButtonClick(Sender: TObject);
    procedure ReadCMOSTimeNativeButtonClick(Sender: TObject);
    procedure ReadCMOSTimeButtonClick(Sender: TObject);
    procedure SoundOffNativeButtonClick(Sender: TObject);
    procedure SoundOnButtonClick(Sender: TObject);
    procedure SoundOffButtonClick(Sender: TObject);
    procedure AltTabButtonClick(Sender: TObject);
    procedure AltTabNativeButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses
  DataModuleUnit;

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  CustomCardDataModule.kdCustomCard1.ModuleLoaded:= True;
  if not CustomCardDataModule.kdCustomCard1.ModuleLoaded then
  begin
    MessageDlg('The GDD is not loaded!', mtInformation, [mbOK], 0, mbOK);
    halt;
  end;

  (* no need to register some card because we are going to work with
     product's auxiliary capabilities *)

{  kdCustomCard1.RegisterCard;
   if not kdCustomCard1.CardRegistered then
   begin
     MessageDlg('Unable to register the card!', mtInformation, [mbOK], 0, mbOK);
     halt;
   end; }
end;


procedure Read_CMOS; assembler;
asm

  cli
  mov eax,0

  mov dx,70h  (* reading hours *)
  mov al,4h
  out dx,al
  mov dx,71h
  in  al,dx

  mov ebx,eax (* shifting *)
  shl ebx,16

  mov dx,70h  (* reading minutes *)
  mov al,2h
  out dx,al
  mov dx,71h
  in  al,dx

  shl ax,8    (* ah - mins *)

  mov dx,70h  (* reading seconds *)
  mov al,0h
  out dx,al
  mov dx,71h
  in  al,dx   (* ah/al : mins/secs*)

  or ebx,eax  (* or'ed with hours*)
  xchg ebx,eax (* saving the result in ax to return *)

  sti
end;

procedure SoundOn; assembler;
asm
  cli
  in ax,61h
  or ax,03h
  out 61h,ax
  mov ax,0b6h
  out 43h,ax
  mov al,0ffh
  out 42h,al
  mov al,02
  out 42h,al
  sti
end;

procedure SoundOff; assembler;
asm
  in ax,61h
  and ax,0fch
  out 61h,ax
end;

procedure PutScanCodeAltDown; assembler;
asm
       mov dl,  38h   (* <- scan code *)
       xor cx,  cx
     @@WaitWhlFull:
       in al,   64h
       test al, 1
       loopnz   @@WaitWhlFull

       push    cx
       push    ax
       xor     cx, cx
     @@TstCmdPortLp:
       in      al, 64h
       test    al, 2
       loopnz  @@TstCmdPortLp
       pop     ax
       pop     cx

       mov al,  0D2h
       out 64h, al

       push    cx
       push    ax
       xor     cx, cx
     @@Tst2:
       in      al, 64h
       test    al, 2
       loopnz  @@Tst2
       pop     ax
       pop     cx

       mov al,  dl
       out 60h, al
end;

procedure PutScanCodeTabDown; assembler;
asm
       mov dl,  0fh   (* <- scan code *)
       xor cx,  cx
     @@WaitWhlFull:
       in al,   64h
       test al, 1
       loopnz   @@WaitWhlFull

       push    cx
       push    ax
       xor     cx, cx
     @@TstCmdPortLp:
       in      al, 64h
       test    al, 2
       loopnz  @@TstCmdPortLp
       pop     ax
       pop     cx

       mov al,  0D2h
       out 64h, al

       push    cx
       push    ax
       xor     cx, cx
     @@Tst2:
       in      al, 64h
       test    al, 2
       loopnz  @@Tst2
       pop     ax
       pop     cx

       mov al,  dl
       out 60h, al
end;

procedure PutScanCodeTabUp; assembler;
asm
       mov dl,  8fh    (* <- scan code *)
       xor cx,  cx
     @@WaitWhlFull:
       in al,   64h
       test al, 1
       loopnz   @@WaitWhlFull

       push    cx
       push    ax
       xor     cx, cx
     @@TstCmdPortLp:
       in      al, 64h
       test    al, 2
       loopnz  @@TstCmdPortLp
       pop     ax
       pop     cx

       mov al,  0D2h
       out 64h, al

       push    cx
       push    ax
       xor     cx, cx
     @@Tst2:
       in      al, 64h
       test    al, 2
       loopnz  @@Tst2
       pop     ax
       pop     cx

       mov al,  dl
       out 60h, al
end;


procedure PutScanCodeAltUp; assembler;
asm
       mov dl,  0b8h   (* <- scan code *)
       xor cx,  cx
     @@WaitWhlFull:
       in al,   64h
       test al, 1
       loopnz   @@WaitWhlFull

       push    cx
       push    ax
       xor     cx, cx
     @@TstCmdPortLp:
       in      al, 64h
       test    al, 2
       loopnz  @@TstCmdPortLp
       pop     ax
       pop     cx

       mov al,  0D2h
       out 64h, al

       push    cx
       push    ax
       xor     cx, cx
     @@Tst2:
       in      al, 64h
       test    al, 2
       loopnz  @@Tst2
       pop     ax
       pop     cx

       mov al,  dl
       out 60h, al
end;


procedure TForm1.ReadCMOSTimeNativeButtonClick(Sender: TObject);
var
  FuncName:String;
  TimeString: String;
begin
  FuncName:= 'Read_CMOS';
  TimeString:= IntToHex(CustomCardDataModule.kdCustomCard1.ExecNativeKernelRoutine(FuncName),6);
  ReadCMOSTimeNativeLabel.Caption:= Copy(TimeString,1,2)+':'+Copy(TimeString,3,2)+':'+Copy(TimeString,5,2);
end;

procedure TForm1.SoundOnNativeButtonClick(Sender: TObject);
var
  ProcName: String;
begin
  ProcName:= 'SoundOn';
  CustomCardDataModule.kdCustomCard1.ExecNativeKernelRoutine(ProcName);
end;

procedure TForm1.SoundOffNativeButtonClick(Sender: TObject);
var
  ProcName: String;
begin
  ProcName:= 'SoundOff';
  CustomCardDataModule.kdCustomCard1.ExecNativeKernelRoutine(ProcName);
end;

procedure TForm1.AltTabNativeButtonClick(Sender: TObject);
begin
  MessageDlg('Implement the corresponding code yourself after seeing how a similar one works via CallUserCodeFromKernel method.', mtInformation, [mbOk], 0, mbOk);
end;


procedure TForm1.ReadCMOSTimeButtonClick(Sender: TObject);
var
  TimeString: String;
begin
//   Read_CMOS;
//   You will be protected from execution 'in' and 'out' assembler instructions
//   directly in the user mode. The only allowable way is through the wrapper:
  TimeString:= IntToHex(CustomCardDataModule.kdCustomCard1.CallUserCodeFromKernel(@Read_CMOS),6);
  ReadCMOSTimeLabel.Caption:= Copy(TimeString,1,2)+':'+Copy(TimeString,3,2)+':'+Copy(TimeString,5,2);
end;


procedure TForm1.SoundOnButtonClick(Sender: TObject);
begin
//   You will be protected from execution 'in' and 'out' assembler instructions
//   directly in the user mode. The only allowable way is through the wrapper:
  CustomCardDataModule.kdCustomCard1.CallUserCodeFromKernel(@SoundOn);
end;

procedure TForm1.SoundOffButtonClick(Sender: TObject);
begin
//   You will be protected from execution 'in' and 'out' assembler instructions
//   directly in the user mode. The only allowable way is through the wrapper:
  CustomCardDataModule.kdCustomCard1.CallUserCodeFromKernel(@SoundOff);
end;

procedure TForm1.AltTabButtonClick(Sender: TObject);
begin
//   You will be protected from execution 'in' and 'out' assembler instructions
//   directly in the user mode. The only allowable way is through the wrapper:
  with CustomCardDataModule do
  begin
    kdCustomCard1.CallUserCodeFromKernel(@PutScanCodeAltDown);
    kdCustomCard1.CallUserCodeFromKernel(@PutScanCodeTabDown);
    kdCustomCard1.CallUserCodeFromKernel(@PutScanCodeTabUp);
    kdCustomCard1.CallUserCodeFromKernel(@PutScanCodeAltUp);
  end;  
end;

end.
