/*
 * Source file for KylixDriver's GDD module.
 *
 * This file may be distributed only as part of the
 * application you are distributing, and only if it
 * significantly contributes to the functionality of your
 * application. (see kylixdriver.htm(l) for details).
 *
 * Web site: http://etsoftware.tripod.com/index.html
 * Email:    etsoft@tenzor.net
 *
 * (C) ETSoft Tenzor.Net 2002 - 2005
 */

#ifdef __KERNEL__

#include "chardev.h"

/* NUMBER OF FREE PAGES TO SAVE INTERRUPT INFO

   fpo variable is the power of 3 (currently 1<<3=8) to multiply PAGE_SIZE (= 4096) to.
   It is used for allocation the buffer to store interrupts info.
   4096 * 8 = 32K / 16 = 2048 items are reserved to be gotten from driver in time
*/

const int fpo = 3;

/*
   Do not increment it if not necessary.
   Otherwize you should increase NR_TIMEVAL (currently 2048) constant
   defined in chardev.h file as well, as twice as it is now

   You can only do this if you have chardev.c source file
*/

#define   PRINTK_TYPE_APPLICATION_TTY   1
#define   PRINTK_TYPE_DEBUG             2
#define   PRINTK_TYPE_NONE              3
#define   PRINTK_TYPE_DESIGN_LOG        4  // for design-time logging, not yet implemented

const int printk_type = PRINTK_TYPE_NONE;
/*const int printk_type = PRINTK_TYPE_APPLICATION_TTY;*/
/*const int printk_type = PRINTK_TYPE_DEBUG;*/


int mmap_call_result;  // only for 2.4 kernels
void *core_symbol;     // pointer to a core symbol;
InterruptDevice *InterruptDevicesListHead;  

#endif /* __KERNEL__ */

