/*
 * Common header file for KylixDriver's GDD module.
 *
 * This file may be distributed only as part of the 
 * application you are distributing, and only if it 
 * significantly contributes to the functionality of your 
 * application. (see kylixdriver.htm(l) for details).
 *
 * Web site: http://etsoftware.tripod.com/index.html
 * Email:    etsoft@tenzor.net
 *
 * (C) ETSoft Tenzor.Net 2002 - 2005
 */

#ifndef _KDCOMMON_H_
#define _KDCOMMON_H_
#include <linux/version.h>

#ifndef VERSION_CODE
#  define VERSION_CODE(vers,rel,seq) ( ((vers)<<16) | ((rel)<<8) | (seq) )
#endif

/* only allow major releases */
#if LINUX_VERSION_CODE < VERSION_CODE(2,4,0) /* not < 2.4 */
#  error "This kernel is too old: not supported by this file"
#endif
#if LINUX_VERSION_CODE > VERSION_CODE(2,7,0) /* not > 2.6, by now */
#  error "This kernel is too recent: not supported by this file"
#endif
#if (LINUX_VERSION_CODE & 0xff00) == 3 /* not 2.3 */
#  error "Please don't use linux-2.3, use 2.4 or 2.6 instead"
#endif
#if (LINUX_VERSION_CODE & 0xff00) == 5 /* not 2.5 */
#  error "Please don't use linux-2.5, use 2.6 instead"
#endif

#endif

/* remember current Linux version */
#if LINUX_VERSION_CODE < VERSION_CODE(2,5,0)
#  define LINUX_24
#elif LINUX_VERSION_CODE < VERSION_CODE(2,7,0)
#  define LINUX_26
#  if LINUX_VERSION_CODE > VERSION_CODE(2,6,5)
#    define LINUX_266
#  endif
#  if LINUX_VERSION_CODE >= VERSION_CODE(2,6,9)
#    define LINUX_269
#  endif
#  if LINUX_VERSION_CODE >= VERSION_CODE(2,6,10)
#    define LINUX_2610
#  endif
#else
#error "unsuppored linux kernel version"
#endif

#if defined(LINUX_26) || defined(LINUX_24)
    #define LINUX_24_26
#endif


#include <linux/config.h>
#if defined(LINUX_24)
#if defined(CONFIG_MODVERSIONS) && !defined(MODVERSIONS)
    #define MODVERSIONS
#endif
#if defined(MODVERSIONS)
    #include <linux/modversions.h>
#endif
#include <linux/init.h>
#include <linux/kernel.h>
#endif

