#!/bin/bash
#
# KylixDriver install script
# Copyright(C) 2002-2004
# mailto:etsoft@tenzor.net
#
#
MSGERROR='ERROR:'
MSGINSTPATH='Please enter KylixDriver install path inside your home directory:'

KYLIX1CONF=$HOME'/.borland/delphi60rc'
KYLIX1CONF2=$HOME'/.borland/delphi60rc'
KYLIX2CONF=$HOME'/.borland/delphi65rc'
KYLIX2CONF2=$HOME'/.borland/delphi65rc'
KYLIX3CONF=$HOME'/.borland/delphi69rc'
KYLIX3CONF2=$HOME'/.borland/delphi69rc'
NRKYLIX1SRC='/kylix1'
NRKYLIX2SRC='/kylix2'
NRKYLIX3SRC='/kylix3'

KYLIXDRIVERTAR='kylixdriver3.1.tar'

function CheckKylix {
  if [ -e $KYLIXCONF ]; then
    kxroot=`cat $KYLIXCONF |grep "DelphiRoot="`
    kxroot=`echo $kxroot |awk -F. '{printf substr($1,12)}'`
    Chk=0
  else
    Chk=1
  fi
  return $Chk
}

function BuildPackage {
  cd .$NRKYLIXSRC
  $kxroot/bin/dcc -u$kxroot/lib -o$kxroot/bin ./kdedspkg.dpk
  $kxroot/bin/dcc -u$kxroot/lib -o$kxroot/bin ./kdclxpkg.dpk
  cd ..

  libpath=`grep -A 0 "^Search Path=" $KYLIXCONF2`
#  libpath=`cat $KYLIXCONF2 |grep "Search Path="`
  libpath=`echo $libpath |awk -F. '{printf substr($1,13)}'`
#  libpath=`echo $libpath |awk -F. '{printf substr($1,1,index($1,"Package")-2)}'`
  nnn=':'$teroot$NRKYLIXSRC/rtl
  libpath=`echo $libpath |awk -F. '{printf gensub("'$nnn'","","g",$1)}'`
  libpath=$libpath':'$teroot$NRKYLIXSRC/rtl

  ./Utils/idemagic "$KYLIXCONF2" "Library" "Search Path" "$libpath"
  teso=$libpath'/'
  ./Utils/idemagic "$KYLIXCONF2" "Known Packages" "$teroot$NRKYLIXSRC/dtl/bplkdedspkg.so" "KylixDriver Editors (binary&hexadecimal&decimal&linear)"
  ./Utils/idemagic "$KYLIXCONF2" "Known Packages" "$teroot$NRKYLIXSRC/dtl/bplkdclxpkg.so" "KylixDriver Application Library (c) 2002-2004 ETSoft Tenzor.Net"
  return 1;
}

clear
echo "KylixDriver Evaluation Version 3.1 (c) 2002-2004 ETSoft Tenzor.Net"
echo
echo "Welcome to the KylixDriver Setup Script."
echo
echo "Please shutdown all running Kylix apps"
echo -n "when ready press <Enter>"
read

# -------------------------
# Checking Install File ...

if [ -e $KYLIXDRIVERTAR ]; then
  echo
else
  echo $MSGERROR "KylixDriver Package tar image is not found !"
  exit 0
fi

# --------------------------------
# Request the destination path ...

echo $MSGINSTPATH
echo -n '[The default path inside your home directory is kylixdriver3.1 (change if necessary)]:'
read teroot
if [ "$teroot" = "" ]; then
  teroot=$HOME'/kylixdriver3.1'
else
  teroot=$HOME'/'$teroot  
fi
  
echo
echo 'The full KylixDriver Home Path will be ='$teroot
echo
if [ -e $teroot ]; then
  echo "Copying file ..."
else
  mkdir $teroot
fi

# --------------------------------
# Extract TAR file ...

cp -f $KYLIXDRIVERTAR $teroot
cd $teroot
tar xf $KYLIXDRIVERTAR
rm $KYLIXDRIVERTAR

# --------------------------------
# Checking Kylix1
echo
KYLIXCONF=$KYLIX1CONF
KYLIXCONF2=$KYLIX1CONF2
if ! CheckKylix; then
  echo "Kylix 1 not found."
else
  # --------------------------------
  # Build Package for Kylix1
  echo "Kylix 1 Home Path="$kxroot
  echo "Build package Kylix 1 ..."
  NRKYLIXSRC=$NRKYLIX1SRC
  BuildPackage
  echo
fi

# --------------------------------
# Checking Kylix2
echo
KYLIXCONF=$KYLIX2CONF
KYLIXCONF2=$KYLIX2CONF2
if ! CheckKylix; then
  echo "Kylix 2 not found."
else
  # --------------------------------
  # Build Package for Kylix2
  echo "Kylix 2 Home Path="$kxroot
  echo "Build package Kylix 2 ..."
  NRKYLIXSRC=$NRKYLIX2SRC
  BuildPackage
  echo
fi

# --------------------------------
# Checking Kylix3
echo
KYLIXCONF=$KYLIX3CONF
KYLIXCONF2=$KYLIX3CONF2
if ! CheckKylix; then
  echo "Kylix 3 not found."
else
  # --------------------------------
  # Build Package for Kylix3
  echo "Kylix 3 Home Path="$kxroot
  echo "Build package Kylix 3 ..."
  NRKYLIXSRC=$NRKYLIX3SRC
  BuildPackage
  echo
fi

rm -f ./Utils/idemagic

echo "Compiling the Generic Device Driver (GDD)..."
make clearmakefile
make install
echo
echo "KylixDriver has been successfully installed !"
echo
echo "Please read all the documentation files included"
echo
echo "Contact:"
echo "e-mail: etsoft@tenzor.net"
echo ""
echo -n "press <Enter>"

read
